package de.fhdw.wtf.tooling.builders;

import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResourceDelta;
import org.eclipse.core.resources.IncrementalProjectBuilder;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;

public class WTFProjectBuilder extends IncrementalProjectBuilder {
	
	public static final String BUILDER_ID = "de.fhdw.wtf.tooling.builders.WTFProjectBuilder";
	
	public WTFProjectBuilder() {
	}
	
	@Override
	protected IProject[] build(final int kind, final Map<String, String> args, final IProgressMonitor monitor)
			throws CoreException {
		if (kind == INCREMENTAL_BUILD) {
			if (this.hasWtfModelChanged()) {
				this.build();
			}
		} else {
			this.build();
		}
		return null;
	}
	
	private void build() {
		new CheckCommand(this.getProject()).execute();
	}
	
	private boolean hasWtfModelChanged() {
		final IResourceDelta delta = this.getDelta(this.getProject());
		final IResourceDelta[] affectedChildren = delta.getAffectedChildren();
		for (final IResourceDelta r : affectedChildren) {
			if ("wtf".equals(r.getResource().getFileExtension())) {
				return true;
			}
		}
		return false;
	}
	
}
